//-----------------------------------------------------------------------------
//
//      (1) handler_table
//     
//      This table is used to hold registered performative handler 
//      scripts.  It should have exactly one pre-defined entry per
//      legal kqml performative, and one for a default handler.
//
//-----------------------------------------------------------------------------
// $Id: TKqmlTab.C,v 1.5 1997/06/04 16:36:34 ian Exp $

#include <stdio.h>
#include <stdlib.h>
#include <tcl.h>
#include <tk.h>
#include <kqml.h>
#include <TKqml.h>
#include <TKqmlTab.h>

HANDLER_TABLE handler_table[] = {
    {"achieve", NULL, 0},
    {"advertise", NULL, 0},
    {"ask-about", NULL, 0},
    {"ask-all", NULL, 0},
    {"ask-if", NULL, 0},
    {"ask-one", NULL, 0},
    {"break", NULL, 0},
    {"broadcast", NULL, 0},
    {"broker-all", NULL, 0},
    {"broker-one", NULL, 0},
    {"deny", NULL, 0},
    {"delete", NULL, 0},
    {"delete-all", NULL, 0},
    {"delete-one", NULL, 0},
    {"discard", NULL, 0},
    {"eos", NULL, 0},
    {"error", NULL, 0},
    {"evaluate", NULL, 0},
    {"forward", NULL, 0},
    {"generator", NULL, 0},
    {"insert", NULL, 0},
    {"monitor", NULL, 0},
    {"next", NULL, 0},
    {"pipe", NULL, 0},
    {"ready", NULL, 0},
    {"recommend-all", NULL, 0},
    {"recommend-one", NULL, 0},
    {"recruit-all", NULL, 0},
    {"recruit-one", NULL, 0},
    {"register", NULL, 0},
    {"reply", NULL, 0},
    {"rest", NULL, 0},
    {"sorry", NULL, 0},
    {"standby", NULL, 0},
    {"stream-about", NULL, 0},
    {"stream-all", NULL, 0},
    {"standyby", NULL, 0},
    {"stream-about", NULL, 0},
    {"stream-all", NULL, 0},
    {"subscribe", NULL, 0},
    {"tell", NULL, 0},
    {"transport-address", NULL, 0},
    {"unregister", NULL, 0},
    {"untell", NULL, 0}, 
#ifdef KQML_PERF_EXTENSIONS
    {"unsubscribe", NULL, 0},
#endif
};

const int kqml_numhand = ( sizeof (handler_table) /
			  sizeof (struct handler_script));
			 
//-----------------------------------------------------------------------------
//
//      (2) kqml_cmd
//
//      This array specifies all of the Kril commands available to Tcl.
//      A function is available to Tcl if a mount is provided to align
//      the parameters; it is the mount names that are actually listed
//      here.  
//
//      Note that kqml_register is an exception; it is written specific-
//      ally for this application to handle script registration.
//      note: 0 parameters = unknown/variable
//
//-----------------------------------------------------------------------------

KQML_CMDARRAY kqml_cmdarray[] = {
  {"NA",              0,0, {NUL,  NUL,  NUL,  NUL,  NUL,  NUL, NUL,  NUL},NUL},
  {"NA",              0,0, {NUL,  NUL,  NUL,  NUL,  NUL,  NUL, NUL,  NUL},NUL},
  {"NA",              0,0, {NUL,  NUL,  NUL,  NUL,  NUL,  NUL, NUL,  NUL},NUL},
  {"NA",              0,0, {NUL,  NUL,  NUL,  NUL,  NUL,  NUL, NUL,  NUL},NUL},
  {"send_msg",        6,2, {INT,  PCHAR,PCHAR,PCHAR,PCHAR,PPOBJ,NUL,  NUL},INT},
  /**********/
  {"send_msgv-NA",       8,0, {INT,  PCHAR,PCHAR,PCHAR,PCHAR,PPOBJ,QCHAR,QCHAR},INT},
  {"send",            3,0, {INT,  POBJ, PPOBJ, NUL,  NUL,  NUL, NUL,  NUL},INT},
  {"deliver_msg",     2,2, {PCHAR,PCHAR,NUL,  NUL,  NUL,  NUL, NUL,  NUL},INT},
  {"deliver_msgv-NA",    4,0, {PCHAR,PCHAR,QCHAR,QCHAR,NUL,  NUL, NUL,  NUL},INT}, 
  {"deliver",         2,0, {POBJ, PPOBJ, NUL,  NUL,  NUL,  NUL, NUL,  NUL},INT},
  /**********/
  {"build_msg",       4,2, {PCHAR,PCHAR,PCHAR,PCHAR,NUL,  NUL, NUL,  NUL},POBJ},
  {"build_msgv-NA",      4,0, {PCHAR,PCHAR,PCHAR,PCHAR,NUL,  NUL, NUL,  NUL},POBJ},
  {"get_performative",1,0, {POBJ, NUL,  NUL,  NUL,  NUL,  NUL, NUL,  NUL},PCHAR},
  {"get_field",       4,0, {PCHAR,POBJ, PINT, PKET, NUL,  NUL, NUL,  NUL},PCHAR},
  {"get_field_count", 1,0, {POBJ, NUL,  NUL,  NUL,  NUL,  NUL, NUL,  NUL},INT},
  /**********/
  {"get_ith_field",   6,0, {INT,  POBJ, QCHAR,QCHAR,PINT, PKET,NUL,  NUL},PCHAR},
  {"put_performative",2,0, {POBJ, PCHAR,NUL,  NUL,  NUL,  NUL, NUL,  NUL},INT},
  {"put_field",       4,0, {PCHAR,POBJ ,PCHAR,INT,  NUL,  NUL, NUL,  NUL},INT},
  {"put_embedded_msg",3,0, {PCHAR,POBJ, POBJ, NUL,  NUL,  NUL, NUL,  NUL},INT},
  {"build_kmsg_list", 2,0, {POBJ, POBJ, NUL,  NUL,  NUL,  NUL, NUL,  NUL},POBJ},
  /**********/
  {"free_kmsg_list",  1,0, {POBJ, NUL,  NUL,  NUL,  NUL,  NUL, NUL,  NUL},NUL},
  {"print_kmsg_list", 2,0, {POBJ, POBJ, NUL,  NUL,  NUL,  NUL, NUL,  NUL},NUL},
  {"print_msg",       2,0, {POBJ, POBJ, NUL,  NUL,  NUL,  NUL, NUL,  NUL},NUL},
  {"sprint_msg",      3,0, {PCHAR,PINT, POBJ, NUL,  NUL,  NUL, NUL,  NUL},PCHAR},
  {"parse_buffer",    4,0, {PCHAR,INT,  PINT, PPOBJ, NUL,  NUL, NUL,  NUL},INT},
  /**********/
  {"parse_stream",    2,0, {POBJ, PPOBJ, NUL,  NUL,  NUL,  NUL, NUL,  NUL},INT},
  {"parse_fd",        2,0, {INT,  PPOBJ, NUL,  NUL,  NUL,  NUL, NUL,  NUL},INT},
  {"timings",         0,0, {NUL,  NUL,  NUL,  NUL,  NUL,  NUL, NUL,  NUL},INT},
  {"timings_start",   0,0, {NUL,  NUL,  NUL,  NUL,  NUL,  NUL, NUL,  NUL},NUL},
  {"timings_stop",    0,0, {NUL,  NUL,  NUL,  NUL,  NUL,  NUL, NUL,  NUL},NUL},
  /**********/
  {"logging",         0,0, {NUL,  NUL,  NUL,  NUL,  NUL,  NUL, NUL,  NUL},INT},
  {"logging_start",   0,0, {NUL,  NUL,  NUL,  NUL,  NUL,  NUL, NUL,  NUL},NUL},
  {"logging_stop",    0,0, {NUL,  NUL,  NUL,  NUL,  NUL,  NUL, NUL,  NUL},NUL},
  {"wrapper",         2,0, {KRT,  POBJ, NUL,  NUL,  NUL,  NUL, NUL,  NUL},POBJ},
  {"unwrapper",       0,0, {POBJ, PKRT, NUL,  NUL,  NUL,  NUL, NUL,  NUL},POBJ},
  /**********/
  {"stricmp",         2,0, {PCHAR,PCHAR,NUL,  NUL,  NUL,  NUL, NUL,  NUL},INT},
  {"strincmp",        3,0, {PCHAR,PCHAR,INT,  NUL,  NUL,  NUL, NUL,  NUL},INT},
  {"NA",              0,0, {NUL,  NUL,  NUL,  NUL,  NUL,  NUL, NUL,  NUL},INT},
  {"NA",              0,0, {NUL,  NUL,  NUL,  NUL,  NUL,  NUL, NUL,  NUL},INT},
  {"NA",              0,0, {NUL,  NUL,  NUL,  NUL,  NUL,  NUL, NUL,  NUL},INT},
  /**********/
  {"NA",              0,0, {NUL,  NUL,  NUL,  NUL,  NUL,  NUL, NUL,  NUL},INT},
  {"critical_section_start",0,0,{NUL,NUL,NUL, NUL,  NUL,  NUL, NUL,  NUL},NUL},
  {"critical_section_end",0,0,{NUL,NUL, NUL,  NUL,  NUL,  NUL, NUL,  NUL},NUL}
};

const int kqml_numcmds = ( sizeof (kqml_cmdarray) / 
			  sizeof (struct kqml_cmd));

TTYPE_CMDARRAY ttype_cmdarray[] = {
  {NUL,    derive_nul},
  {INT,    derive_int},
  {PINT,   derive_pint},
  {CHAR,   derive_char},
  {PCHAR,  derive_pchar},
  {POBJ,   derive_pobj},
  {KET,    derive_ket},
  {PKET,   derive_pket},
  {KRT,    derive_krt},
  {PKRT,   derive_pkrt},
  {PPOBJ,  derive_ppobj}
};

const int ttype_numcmds = ( sizeof (ttype_cmdarray) / 
			   sizeof (struct ttype_cmd));

char *tkqml_reply_type[] = {
  "KQML_REPLY_ERROR",
  "KQML_REPLY_NONE",
  "KQML_REPLY_KMSG_LIST",
  "KQML_REPLY_KMSG",
  "KQML_REPLY_KMSG_ARRAY",
  "KQML_REPLY_STRING",
  "KQML_REPLY_STRING_ARRAY",
  "KQML_REPLY_BIN",
  "KQML_REPLY_BIN_ARRAY",
  "KQML_REPLY_LONG",
  "KQML_REPLY_LONG_ARRAY", 
  "KQML_REPLY_ULONG", 
  "KQML_REPLY_ULONG_ARRAY"
};

const int num_tkqml_reply_type = sizeof (tkqml_reply_type); 

char *krt_name_lookup(KQML_REPLY_TYPE idx) {
  if (idx < num_tkqml_reply_type) return(tkqml_reply_type[idx]);
  else TKqml_Exit(TInterp,TKQML_ENUM_TYPE_ERROR,TKQML_STATIC,TCL_ERROR);
}

int krt_enum_lookup(char *s, KQML_REPLY_TYPE *krt) {
  int i;

  for (i=0; i<num_tkqml_reply_type; i++)
    if (strcmp(s,tkqml_reply_type[i])==0) {
      *krt=(KQML_REPLY_TYPE)i;
      return(TCL_OK);
    }
  return(TCL_ERROR);
}
  
char *tkqml_expression_type[] = {
  "KQML_TYPE_UNKNOWN",    
  "KQML_TYPE_WORD",     
  "KQML_TYPE_STRING",
  "KQML_TYPE_BYTE",     
  "KQML_TYPE_QUOTED",
  "KQML_TYPE_COMMA",    
  "KQML_TYPE_SEXPR"
};

const int num_tkqml_expression_type = sizeof (tkqml_expression_type); 

char *ket_name_lookup(kqml_expression_type idx) {
  if (idx < num_tkqml_expression_type) return(tkqml_expression_type[idx]);
  TKqml_Exit(TInterp,TKQML_ENUM_TYPE_ERROR,TKQML_STATIC,TCL_ERROR);
}

int ket_enum_lookup(char *s, kqml_expression_type *ket) {
  int i;

  for (i=0; i<num_tkqml_expression_type; i++)
    if (strcmp(s,tkqml_expression_type[i])==0) {
      *ket=(kqml_expression_type)i;
      return(TCL_OK);
    }
  return(TCL_ERROR);
}
  



















